=begin
Copyright 2013, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
###
Usage:
TIG.mtlgamma4octane
typed into the Ruby Console + <enter>
###
Action:
Converts all MTL files in the selected folder into Octane friendly Linear Gamma 
format for Ka/Kd RGB values [**2.2], the originals are renamed with a .OLD 
suffix, useful if you decide to revert then you can delete/rename them...
###
Donations:
Via PayPal.com info @ revitrev.org
###
Version:
1.0 20130329 First Issue
###
=end
require('sketchup.rb')
module TIG
	def TIG.mtlgamma4octane()
		dir=UI.openpanel("TIG.mtlgamma4octane: Choose MTL folder...", Dir.pwd, "*.mtl")
		return nil unless dir
		dir=File.dirname(dir)
		num=0
		Dir.entries(dir).each{|f|
			next unless File.extname(f).downcase==".mtl"
			path=File.join(dir, f)
			old=f+'.OLD'
			File.rename(path, old)
			### 'copy' mtlin [old] into new mtl using original name
			mtlin=File.join(dir, old)
			###
			fio=File.open(path, "w")
			lines=IO.readlines(mtlin)
			lines.each{|line|
				if line=~/^K[ad] /
					line.chomp!
					k,r,g,b = line.split(' ')
					r="%.6g" % r.to_f**2.2
					g="%.6g" % g.to_f**2.2
					b="%.6g" % b.to_f**2.2
					line="#{k} #{r} #{g} #{b}"
				end
				fio.puts(line)
			}
			fio.close
			num+=1
		}
		puts "\n#{num} MTL files in #{dir} converted to Octane 'Linear Gamma' \nformat RGB values for Ka/Kd.\nOriginal x.MTL files renamed x.MTL.OLD\nincase you want to revert..."
		UI.openURL("file:///#{dir}")
	end
end
